#include "grpnode.h"
char *ZC_usage = "usage: grpanal [-d] [-s#] perm_grp_desc_file <configurations";
char opt_d;
char opt_q;
char opt_s;
static char *arg_strings[1];
main(argc, argv)
char **argv;
{
char **new_argv, **save_argv, *s, *t, *ae_malloc(), *getenv();
int new_argc, save_argc, status, i;
static char *single[3];
static char badoptmix[] = "cannot set options -%s simultaneously";

t = badoptmix; /* supress compiler warning */
single[0] = *argv;
save_argv = argv;
save_argc = argc;
new_argv = argv+1;
new_argc = 0;
for(++argv, --argc; argc; ++argv, --argc) {
s = *argv;
if(*s != '-' || !s[1]) { /* regular arg, no options */
*new_argv++ = s;
++new_argc;
continue;
}

for(++s; *s; ++s)
switch(*s) {
case 'd': opt_d = 1; continue;
case 'q': opt_q = 1; continue;
case 's':
if(!s[1] || s[2]) usage();
opt_s = *++s;
continue;
default: usage(); /* unknown option */
} /* end switch on option */
} /* end options */

status = 0;
argv = save_argv;
argc = ++new_argc;
if(argc < save_argc) argv[argc] = 0;
/* at this point it looks like main was called with just the args,
 * options are magically set. */
if(argc <= 1) usage();
if(argc > 2) usage();
arg_strings[0] = argv[1];
argv[1] = argv[0]; argv += 1; argc -= 1;
status = flatmain(arg_strings[0]);
exit(status);
} /* main */

extern char *ZC_prevlink;
#define ZC_NEXTLINK(ptr, offset) *((char **)ptr+2*offset)
#define ZC_PREVLINK(ptr, offset) *((char **)ptr+2*offset + 1)
struct connect *ZC_insert_connect(list, t, copy,a0)
struct connect *a0;
struct list_connect *list;
struct connect *t;
{
struct connect *s = 0;

if(!t) eclib_error(NODE_NULL_PTR, 9);
if(!list) eclib_error(NODE_NULL_PTR, 10);
if(copy) t = copy_connect(t);

/* call ZC_o_listlink for each ordering of this list */
if(ZC_prevlink = (char*)a0)
ZC_prevlink = ZC_PREVLINK(ZC_prevlink, 0);
else ZC_prevlink = ZC_PREVLINK(list, 0);
ZC_o_listlink((char **)list, (char*)t, 0);

++list->n_nodes;
return t;
} /* ZC_insert_connect */

struct connect *append_connect(list, t)
struct list_connect *list;
struct connect *t;
{
return insert_connect(list, t
,(struct connect *)0 );
} /* append_connect */

struct connect *copy_append_connect(list, t)
struct list_connect *list;
struct connect *t;
{
return copy_insert_connect(list, t
,(struct connect *)0);
} /* copy_append_connect */

struct connect *prepend_connect(list, t)
struct list_connect *list;
struct connect *t;
{
return insert_connect(list, t
,list->head);
} /* prepend_connect */

struct connect *copy_prepend_connect(list, t)
struct list_connect *list;
struct connect *t;
{
return copy_insert_connect(list, t
,list->head);
} /* copy_prepend_connect */

struct list_connect  trail;
struct perm *ZC_insert_perm(list, t, copy,a0)
struct perm *a0;
struct list_perm *list;
struct perm *t;
{
struct perm *s = 0;

if(!t) eclib_error(NODE_NULL_PTR, 9);
if(!list) eclib_error(NODE_NULL_PTR, 10);
if(copy) t = copy_perm(t);

/* call ZC_o_listlink for each ordering of this list */
if(ZC_prevlink = (char*)a0)
ZC_prevlink = ZC_PREVLINK(ZC_prevlink, 0);
else ZC_prevlink = ZC_PREVLINK(list, 0);
ZC_o_listlink((char **)list, (char*)t, 0);

++list->n_nodes;
return t;
} /* ZC_insert_perm */

struct perm *append_perm(list, t)
struct list_perm *list;
struct perm *t;
{
return insert_perm(list, t
,(struct perm *)0 );
} /* append_perm */

struct perm *copy_append_perm(list, t)
struct list_perm *list;
struct perm *t;
{
return copy_insert_perm(list, t
,(struct perm *)0);
} /* copy_append_perm */

struct perm *prepend_perm(list, t)
struct list_perm *list;
struct perm *t;
{
return insert_perm(list, t
,list->head);
} /* prepend_perm */

struct perm *copy_prepend_perm(list, t)
struct list_perm *list;
struct perm *t;
{
return copy_insert_perm(list, t
,list->head);
} /* copy_prepend_perm */


short permsize; /* size of permutations */
short pathlen;
short remap_mode;
/* nontrivial coset reps at level n, link lists */
struct list_perm cosrep[PERMSIZE];
struct perm *idn; /* identity permutation */
/* the initial moves */
short num_moves, num_rots;
char movename[NUM_MOVES];
short *moveperm[NUM_MOVES];
short *rots[NUM_MOVES];

short ZC_max_malloc = 200, ZC_max_struct = 2;
struct { char *block; unsigned char level; } ZC_inmem[200];
char *struct_avail[2][4];
long num_gets[2][4], num_frees[2][4], num_avails[2][4];
struct STRUCT_DESC struct_desc[] = {
{"connect", (sizeof(struct connect) + 3) & ~3,
 -1,0,0,0,0,1,4,-1,0,0,0},
{"perm", (sizeof(struct perm) + 3) & ~3,
 -1,0,0,0,0,1,4,-1,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0}
};

struct IDX_DESC idx_desc[] = {
{0,0,0,0,0,0,0,0,0,0}
};


/* end of generated source file, copy this comment just to make sure
 * we aren't out of disk space.  The source copy routine checks for this. */
